import numpy as np
import json
import numpy as np


'''
读取源文件处理
'''
a = np.loadtxt('network.txt') 
b = np.loadtxt('community.txt') 

'''
提取分组
'''
cluster = []
for i in b:
	cluster.append(int(i[1]))

len_nodes = len(cluster)

x = []
y = []
for i in a:
	x.append(int(i[0]-1))
	y.append(int(i[1]-1))

z = []
lenth = len(x)
for i in range (lenth):
	zi = []
	zi.append(x[i])
	zi.append(y[i])
	z.append(zi)
#print(z)


'''
生成网络邻接矩阵
'''

Net = [[0 for c in range(len_nodes)]for r in range(len_nodes)]

for i in z :
	p = i[0]
	q = i[1]
	Net[p][q] = 1


#统计每个节点与哪些点相连，neibors
neibors = [ ]
ori_weight = [ ]
un_connect = [  ]
for i,x in enumerate( Net ):
	
	neibor_i = [ ]
	ori_weight_i = [ ]
	un_connect_i = [ ]
	for j,y in enumerate(x):
		
		if y != 0:
			neibor_i.append( j )
			ori_weight_i.append( y )
		else:
			un_connect_i.append(j)
	neibors.append( neibor_i )
	ori_weight.append( ori_weight_i )
	un_connect.append( un_connect_i )


print(len(neibors))


#存网络
file_name = 'Net.json'
with open(file_name,'w') as f_obj:
	json.dump(Net,f_obj)


#存邻居
name1 = 'Ori_neibors'
name2 = '.json'
file_name = name1 + name2
with open(file_name,'w') as f_obj:
	json.dump(neibors,f_obj)


#存分组
file_name = 'cluster.json'
with open(file_name,'w') as f_obj:
	json.dump(cluster,f_obj)


