import numpy as np

import random 



'''
除了S以外的状态进行转换的各种情况
'''

choose = [0,1,3,4,6,7]
#0是隔离Q，1是易感S，3是潜伏E，4是感染I，6是恢复R，7是死亡D（仅作说明，不进程序）


'''
Q 转变情况
'''
def Q_trans(x, len_nodes, itselves, E_days, Ei, neibors, qi):
	if E_days[x] < Ei:					#被隔离潜伏期内可能确诊
		n = np.random.random( )
		if n < qi:
			itselves[x] = 4
		else:
			E_days[x] += 1
	else:								#过了隔离期恢复正常
		itselves[x] = 1
		
	return itselves[x],E_days[x]


'''
E 转变情况
'''
def E_trans(x,len_nodes,itselves,E_days,Ei,neibors,sige):
	E_days[x] = 0
	n = np.random.random()
	
	if n < sige:
		itselves[x] = 4				#E 确诊为症状感染者I
	else:
		itselves[x] = 3
		
	return itselves[x],E_days[x]


'''
I 转变情况
'''
def I_trans(x, len_nodes, itselves, E_days, Ei, neibors, gama, alpha):
	E_days[x] = 0
	n = np.random.random()
	
	if n < alpha:					#I 治疗成 D
		itselves[x] = 7
	elif n < gama:
		itselves[x] = 6				#I 治疗成 R
	else :
		itselves[x] = 4

	return itselves[x],E_days[x]

